std::__debug::list< _Tp, _Allocator > Class Template Reference
Inheritance diagram for std::__debug::list< _Tp, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< _Base_const_iterator, list > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< _Base_iterator, list > | iterator
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef _Tp | value_type

## Public Member Functions

template<class _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
| list (_InputIterator __first, _InputIterator __last, const _Allocator &__a=_Allocator())
| list (const _Allocator &__a) noexcept
| list (const _Base &__x)
| list (const list &)=default
| list (const list &__x, const allocator_type &__a)
| list (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
| list (list &&)=default
| list (list &&__x, const allocator_type &__a)
| list (size_type __n, const _Tp &__value, const _Allocator &__a=_Allocator())
| list (size_type __n, const allocator_type &__a=allocator_type())
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
void | _M_invalidate_if (_Predicate __pred)
void | _M_swap (_Safe_container &__x) noexcept
void | _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)
template<class _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
void | assign (_InputIterator __first, _InputIterator __last)
void | assign (initializer_list< value_type > __l)
void | assign (size_type __n, const _Tp &__t)
const_reference | back () const noexcept
reference | back () noexcept
const_iterator | begin () const noexcept
iterator | begin () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
iterator | emplace (const_iterator __position, _Args &&... __args)
const_iterator | end () const noexcept
iterator | end () noexcept
iterator | erase (const_iterator __first, const_iterator __last) noexcept
iterator | erase (const_iterator __position) noexcept
const_reference | front () const noexcept
reference | front () noexcept
iterator | insert (const_iterator __p, initializer_list< value_type > __l)
template<class _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
iterator | insert (const_iterator __position, _InputIterator __first, _InputIterator __last)
iterator | insert (const_iterator __position, _Tp &&__x)
iterator | insert (const_iterator __position, const _Tp &__x)
iterator | insert (const_iterator __position, size_type __n, const _Tp &__x)
void | merge (list &&__x)
template<class _Compare >
void | merge (list &&__x, _Compare __comp)
void | merge (list &__x)
template<typename _Compare >
void | merge (list &__x, _Compare __comp)
list & | operator= (const list &)=default
list & | operator= (initializer_list< value_type > __l)
list & | operator= (list &&)=default
void | pop_back () noexcept
void | pop_front () noexcept
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
void | remove (const _Tp &__value)
template<class _Predicate >
void | remove_if (_Predicate __pred)
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
void | resize (size_type __sz)
void | resize (size_type __sz, const _Tp &__c)
void | sort ()
template<typename _StrictWeakOrdering >
void | sort (_StrictWeakOrdering __pred)
void | splice (const_iterator __position, list &&__x) noexcept
void | splice (const_iterator __position, list &&__x, const_iterator __first, const_iterator __last) noexcept
void | splice (const_iterator __position, list &&__x, const_iterator __i) noexcept
void | splice (const_iterator __position, list &__x) noexcept
void | splice (const_iterator __position, list &__x, const_iterator __first, const_iterator __last) noexcept
void | splice (const_iterator __position, list &__x, const_iterator __i) noexcept
void | swap (list &__x) noexcept(/*conditional */)
void | unique ()
template<class _BinaryPredicate >
void | unique (_BinaryPredicate __binary_pred)

## Protected Member Functions

void | _M_invalidate_all ()
_Safe_container & | _M_safe () noexcept

## Detailed Description

### template<typename _Tp, typename _Allocator = std::allocator<_Tp>>
class std::__debug::list< _Tp, _Allocator >

Class std::list with safety/checking/debug instrumentation.

Definition at line 45 of file debug/list.

## Member Function Documentation

## _M_invalidate_if()

void __gnu_debug::_Safe_sequence< list< _Tp, std::allocator< _Tp > > >::_M_invalidate_if | ( | _Predicate | __pred | ) |

inherited

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 38 of file safe_sequence.tcc.

## _M_transfer_from_if()

void __gnu_debug::_Safe_sequence< list< _Tp, std::allocator< _Tp > > >::_M_transfer_from_if | ( | _Safe_sequence< list< _Tp, std::allocator< _Tp > > > & | __from,
|  | _Predicate | __pred
| ) |  |

inherited

Transfers all iterators `x` that reference `from` sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 69 of file safe_sequence.tcc.

The documentation for this class was generated from the following file:

- debug/list